/* * * * * * * * * * * * * * * * */
/* IBM REXX                      */
/* Pointlist comparator          */
/* v 0.4 alpha (13.8.99)         */
/* (c) 1999 Boris Bogdanov,      */
/* 2:5055/52@Fidonet             */
/* * * * * * * * * * * * * * * * */
/*  
	    ࠭⨩ ⭮⥫쭮 ࠡᯮᮡ 
	 ᭮  ணࠬ,  ᯮ   ᢮   .

	  ᢮ ᯮ짮  ਯ,  
	 ᫮ 祭 ਡ뫨. ᫨   ਤ㬠,    
	 ਡ,  , , 祭 ᭮ ;)

	 ⠪   ⥪ ᮣ᭮ ᢮ ॡ,
	⢥ ॡ - ࠭ 뫪  .
*/

/*  ६, ॡ騥 易⥫쭮 ன. */
file_new = 'pnt5055.ndl'
file_old = 'pnt5055.old'
repfile  = 'repfile.rep'

/* ᬥ⨪ */
separator1 = ''
separator2 = ''
wrap_ident = 78 /*   ப. */

soft_sign = 'pointlist comparator 0.2/REXX (c) 1999 B.Bogdanov 2:5055/52'
months = '          H '

call RxFuncAdd 'SysFileTree', 'RexxUtil', 'SysFileTree'

time1=time('S')
'@del 'repfile

/* header */
call report separator2
call report 'ࠢ  ⫨⮢:'
call report ' ண: 'filetime(file_old)
call report ' :  'filetime(file_new)

/* H砫   䠩 */
i=0
do while chars(file_new)>0 
 i=i+1; strings_new.i=linein(file_new)
end; strings_new.0=i
/* 稫   䠩 */

/* 砫   䠩 */
i=0
do while chars(file_old)>0 
 i=i+1; strings_old.i=linein(file_old)
end; strings_old.0=i
/* 稫   䠩 */

/* ந    䠩 */
cmaxnode=0; nodes_new=0
do i=1 to strings_new.0
 fc=left(strings_new.i,1)
 select
   when fc=';'
     then nop
   when fc='B'
     then do 
     parse var strings_new.i with 'Boss,'Zone':'Net'/'Node
     index_new.node=i; nodes_new=nodes_new+1
     if Node>cmaxnode then cmaxnode=Node
   end
   when fc='P'
     then do
   end
 otherwise
   nop
 end /*select*/ 
end
maxnode_new=cmaxnode

/* ந   ண 䠩 */
cmaxnode=0; nodes_old=0
do i=1 to strings_old.0
 fc=left(strings_old.i,1)
 select
   when fc=';'
     then nop
   when fc='B'
     then do 
     parse var strings_old.i with 'Boss,'Zone':'Net'/'Node
     index_old.node=i; nodes_old=nodes_old+1
     if Node>cmaxnode then cmaxnode=Node
   end
   when fc='P'
     then do
   end
 otherwise
   nop
 end /*select*/ 
end
maxnode_old=cmaxnode

call report '  'nodes_new' 㧫, max  = 'maxnode_new
call report ' ஬ 'nodes_old' 㧫, max  = 'maxnode_old

do i=1 to Max(maxnode_new,maxnode_old)
  if abbrev(index_old.i,'IN')=1 then index_old.i=-1
  if abbrev(index_new.i,'IN')=1 then index_new.i=-1
end

node_app.0=0 /* ᯨ᮪   */
node_dis.0=0 /* ᯨ᮪ 祧 */
node_sta.0=0 /* ᯨ᮪ ⠢ */
total_nodes_che=0 /* ᥣ   묨 ᥣ⠬ */
total_point_app=0 /* ᥣ  ⮢ */
total_point_dis=0 /* ᥣ 㡨 ⮢ */
total_point_che=0 /* ᥣ ⮢,  窨 */
total_point_new=0 /* ᥣ ⮢    */
total_point_old=0 /* ᥣ ⮢  ஬  */

do i=1 to Max(maxnode_new,maxnode_old)
  if index_old.i<0 & index_new.i<0 then do; nop; end
  if index_old.i<0 & index_new.i>0 then do; j=node_app.0+1; node_app.j=i; node_app.0=j; end
  if index_old.i>0 & index_new.i<0 then do; j=node_dis.0+1; node_dis.j=i; node_dis.0=j; end
  if index_old.i>0 & index_new.i>0 then do; j=node_sta.0+1; node_sta.j=i; node_sta.0=j; end
end

if node_app.0>0 then do
	call report separator2
	call report '> H H'
	call report ' '
	do i=1 to node_app.0
		nodenumber=node_app.i
		stringoffset=index_new.nodenumber
		call report separator1
		/* ⬮⠥ ,  ਥ */
		jj=stringoffset-1
		do while (left(strings_new.jj,1)=';') |(jj=1)
		 jj=jj-1
		end

		do jk=jj+1 to stringoffset-1
			call report strings_new.jk /* 뢮 ਨ */
		end

		call report right(strings_new.stringoffset,length(strings_new.stringoffset)-5)
		j=stringoffset+1
		do while \(left(strings_new.j,1)=';')
		call report wrap(' ',strings_new.j)
		j=j+1
		end
	end
end 
else call report '> H H H'
/* END if node_app.0>0 */

if node_dis.0>0 then do
	call report separator2
	call report '> H H'
	call report ' '
	do i=1 to node_dis.0
		nodenumber=node_dis.i
		stringoffset=index_old.nodenumber
		call report separator1
		/* ⬮⠥ ,  ਥ */
		jj=stringoffset-1
		do while (left(strings_old.jj,1)=';') |(jj=1)
		 jj=jj-1
		end
		do jk=jj+1 to stringoffset-1
			call report strings_old.jk
		end

		call report right(strings_old.stringoffset,length(strings_old.stringoffset)-5)
		j=stringoffset+1
		do while \(left(strings_old.j,1)=';')
		call report wrap(' ',strings_old.j)
		j=j+1
		end
	end
end 
else call report '> H H H'
/* END if node_dis.0>0 */

call report separator2
if node_sta.0>0 then call report '> H H'
		else call report '> H H H'

do i=1 to node_sta.0 /* 横   㧫 */

 drop segment_new. segment_old. segmentindex_new. segmentindex_old.
 nodenumber=node_sta.i
 in=index_new.nodenumber
 io=index_old.nodenumber
 segment_new.0=0
 segment_old.0=0

 /* ந   ᥣ */
 j=in+1; k=0; maxpoint_new=0
 do while \(left(strings_new.j,1)=';')
   k=k+1; segment_new.k=strings_new.j; j=j+1
   parse var segment_new.k with 'Point,'Point','rest
   segmentindex_new.Point=k
   if Point>maxpoint_new then maxpoint_new=Point
 end; segment_new.0=k
 total_point_new=total_point_new+segment_new.0

 /* ந  ண ᥣ*/
 j=io+1; k=0; maxpoint_old=0
 do while \(left(strings_old.j,1)=';')
   k=k+1; segment_old.k=strings_old.j; j=j+1
   parse var segment_old.k with 'Point,'Point','rest
   segmentindex_old.Point=k
   if Point>maxpoint_old then maxpoint_old=Point
 end; segment_old.0=k
 total_point_old=total_point_old+segment_old.0

 do j=1 to max(maxpoint_new, maxpoint_old)
   if abbrev(segmentindex_new.j,'SEG') then segmentindex_new.j=-1
   if abbrev(segmentindex_old.j,'SEG') then segmentindex_old.j=-1
 end


 point_dis.0=0 /* ᯨ᮪ 㡨 ⮢ */
 point_app.0=0 /* ᯨ᮪  ⮢ */
 point_sta.0=0 /* ᯨ᮪  ⮢ */
 point_che.0=0 /* ᯨ᮪  ⮫쪮 祪 */

 do j=1 to max(maxpoint_new, maxpoint_old)
   if (segmentindex_new.j<0) & (segmentindex_old.j>0) then do 
		jj=point_dis.0;	jj=jj+1; point_dis.jj=j; point_dis.0=jj	
		end /* 祧 */
/*   if (segmentindex_new.j<0) & (segmentindex_old.j<0) then nop */ /*  ⠪ */
   if (segmentindex_new.j>0) & (segmentindex_old.j>0) then do 
		jj=point_sta.0; jj=jj+1; point_sta.jj=j; point_sta.0=jj; end 
		/*   (   ஢,    ᠬ ப!) */
   if (segmentindex_new.j>0) & (segmentindex_old.j<0) then do 
		jj=point_app.0; jj=jj+1; point_app.jj=j; point_app.0=jj; end /*  */
 end

 if point_sta.0>0 then
 do j=1 to point_sta.0
  np=point_sta.j
  sn=segmentindex_new.np
  so=segmentindex_old.np
  if \(segment_new.sn=segment_old.so) then do
	h=point_che.0; h=h+1; point_che.h=point_sta.j; point_che.0=h
	end
 end /* point_che ⮢ */
 
 if (point_dis.0>0)|(point_app.0>0)|(point_che.0>0) then do 
		total_nodes_che=total_nodes_che+1
		call report separator1
		call report 'H 'nodenumber
		end

 if point_dis.0>0 then do 
	call report '㤠:'
 	total_point_dis=total_point_dis+point_dis.0
	do j=1 to point_dis.0
		np=point_dis.j
		so=segmentindex_old.np
		call report wrap('- ',segment_old.so)
		end
	end

 if point_app.0>0 then do 
	call report ':'
 	total_point_app=total_point_app+point_app.0
	do j=1 to point_app.0
		np=point_app.j
		sn=segmentindex_new.np
		call report wrap('+ ',segment_new.sn)
		end
	end


 if point_che.0>0 then do 
	call report ':'
	total_point_che=total_point_che+point_che.0
	do j=1 to point_che.0
		np=point_che.j
		sn=segmentindex_new.np
		so=segmentindex_old.np
		call report wrap('o ',segment_old.so)
		call report wrap('n ',segment_new.sn)
		call report ' '
		end
	end
 

end  /*  横   㧫 */


/* footer */
call report separator2
call report ':        뫮          祧            ⠫'
call report '㧫        'format(nodes_old,6)'        'format(node_app.0,6)'      'format(node_dis.0,6)'         'format(total_nodes_che,6)'      'format(nodes_new,6)
call report '      'format(total_point_old,6)'        'format(total_point_app,6)'      'format(total_point_dis,6)'         'format(total_point_che,6)'      'format(total_point_new,6)
call report separator2
time_elapsed=time('S')-time1
call report 'ࠡ⠭ 'strings_old.0 'ப  ஬  'strings_new.0'     'time_elapsed' ᥪ.'
call report soft_sign

call lineout repfile /* ਫ  ᠬ 뢠 䠩 */
exit /*   main() */


report: /* 뢮  䠩  */
call lineout repfile, arg(1)
return

wrap:
w_rest=arg(2); le=arg(1)
parse var w_rest with 'Point,'w_rest
w_rest=le||w_rest
if \(length(w_rest)>wrap_ident) then return w_rest
lp=lastpos(',',left(w_rest,wrap_ident))
wl_ident=copies(' ',pos(',',w_rest))
w_rest=insert(d2c(10)||wl_ident,w_rest,lp)
return w_rest

filetime:
fn=arg(1)
rc=sysFileTree(fn, 'files_stem', 't')
tm=word(files_stem.1,1)
return substr(tm,7,2)'.'word(months,substr(tm,4,2))'.'left(tm,2)'  'substr(tm,10,2)':'right(tm,2)

/*   ᥬ */	